Index: branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zopt.F90
===================================================================
--- branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zopt.F90	(revision 4616)
+++ branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zopt.F90	(revision 4617)
@@ -90,10 +90,7 @@
       ze2(:,:,jpk) = 0._wp
       ze3(:,:,jpk) = 0._wp
-
       !                                        !* attenuation coef. function of Chlorophyll and wavelength (Red-Green-Blue)
       DO jk = 1, jpkm1                         !  --------------------------------------------------------
-!CDIR NOVERRCHK
-         DO jj = 1, jpj
-!CDIR NOVERRCHK
+         DO jj = 1, jpj
             DO ji = 1, jpi
                zchl = ( trn(ji,jj,jk,jpnch) + trn(ji,jj,jk,jpdch) + rtrn ) * 1.e6
@@ -107,9 +104,7 @@
          END DO
       END DO
-
-
+      !
       !                                        !* Photosynthetically Available Radiation (PAR)
       !                                        !  --------------------------------------
-
       IF( ln_varpar ) THEN
          ze1(:,:,1) = par_varsw(:,:) * qsr(:,:) * EXP( -0.5 * zekb(:,:,1) )
@@ -122,7 +117,5 @@
       ENDIF
 
-!CDIR NOVERRCHK
       DO jj = 1, jpj
-!CDIR NOVERRCHK
          DO ji = 1, jpi
             zc1 = ze1(ji,jj,1)
@@ -135,9 +128,6 @@
       END DO
 
-    
       DO jk = 2, nksrp      
-!CDIR NOVERRCHK
-         DO jj = 1, jpj
-!CDIR NOVERRCHK
+         DO jj = 1, jpj
             DO ji = 1, jpi
                zc1 = ze1(ji,jj,jk-1) * EXP( -0.5 * ( zekb(ji,jj,jk-1) + zekb(ji,jj,jk) ) )
@@ -175,7 +165,5 @@
          !
          DO jk = 2, nksrp + 1
-!CDIR NOVERRCHK
             DO jj = 1, jpj
-!CDIR NOVERRCHK
                DO ji = 1, jpi
                   zc0 = ze0(ji,jj,jk-1) * EXP( -fse3t(ji,jj,jk-1) * zxsi0r )
@@ -221,7 +209,5 @@
 
       DO jk = 1, nksrp
-!CDIR NOVERRCHK
-         DO jj = 1, jpj
-!CDIR NOVERRCHK
+         DO jj = 1, jpj
             DO ji = 1, jpi
                IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) ) THEN
@@ -238,7 +224,5 @@
       !
       DO jk = 1, nksrp
-!CDIR NOVERRCHK
-         DO jj = 1, jpj
-!CDIR NOVERRCHK
+         DO jj = 1, jpj
             DO ji = 1, jpi
                IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) ) THEN
@@ -273,4 +257,5 @@
    END SUBROUTINE p4z_opt
 
+
    SUBROUTINE p4z_optsbc( kt )
       !!----------------------------------------------------------------------
Index: branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90
===================================================================
--- branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90	(revision 4616)
+++ branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90	(revision 4617)
@@ -31,5 +31,4 @@
    PUBLIC   p4z_prod_alloc
 
-   !! * Shared module variables
    LOGICAL , PUBLIC ::  ln_newprod      !:
    REAL(wp), PUBLIC ::  pislope         !:
@@ -150,9 +149,6 @@
 
       IF( ln_newprod ) THEN
-!CDIR NOVERRCHK
          DO jk = 1, jpkm1
-!CDIR NOVERRCHK
             DO jj = 1, jpj
-!CDIR NOVERRCHK
                DO ji = 1, jpi
                   ! Computation of the P-I slope for nanos and diatoms
@@ -188,9 +184,6 @@
          END DO
       ELSE
-!CDIR NOVERRCHK
          DO jk = 1, jpkm1
-!CDIR NOVERRCHK
             DO jj = 1, jpj
-!CDIR NOVERRCHK
                DO ji = 1, jpi
 
@@ -231,9 +224,6 @@
       !  Computation of a proxy of the N/C ratio
       !  ---------------------------------------
-!CDIR NOVERRCHK
       DO jk = 1, jpkm1
-!CDIR NOVERRCHK
          DO jj = 1, jpj
-!CDIR NOVERRCHK
             DO ji = 1, jpi
                 zval = MIN( xnanopo4(ji,jj,jk), ( xnanonh4(ji,jj,jk) + xnanono3(ji,jj,jk) ) )   &
@@ -246,11 +236,9 @@
          END DO
       END DO
-
-
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
-
-                IF( etot(ji,jj,jk) > 1.E-3 ) THEN
+               !
+               IF( etot(ji,jj,jk) > 1.E-3 ) THEN
                    !    Si/C of diatoms
                    !    ------------------------
@@ -268,5 +256,5 @@
                   ENDIF
                   zysopt(ji,jj,jk) = grosip * zlim * zsilfac * zsilfac2
-              ENDIF
+               ENDIF
             END DO
          END DO
@@ -296,9 +284,6 @@
 
       ! Computation of the various production terms 
-!CDIR NOVERRCHK
       DO jk = 1, jpkm1
-!CDIR NOVERRCHK
          DO jj = 1, jpj
-!CDIR NOVERRCHK
             DO ji = 1, jpi
                IF( etot(ji,jj,jk) > 1.E-3 ) THEN
@@ -331,9 +316,6 @@
 
       IF( ln_newprod ) THEN
-!CDIR NOVERRCHK
          DO jk = 1, jpkm1
-!CDIR NOVERRCHK
             DO jj = 1, jpj
-!CDIR NOVERRCHK
                DO ji = 1, jpi
                   IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) ) THEN
@@ -359,9 +341,6 @@
          END DO
       ELSE
-!CDIR NOVERRCHK
          DO jk = 1, jpkm1
-!CDIR NOVERRCHK
             DO jj = 1, jpj
-!CDIR NOVERRCHK
                DO ji = 1, jpi
                   IF( etot(ji,jj,jk) > 1.E-3 ) THEN
Index: branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90
===================================================================
--- branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 4616)
+++ branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 4617)
@@ -15,5 +15,5 @@
    USE oce_trc         !  shared variables between ocean and passive tracers
    USE trc             !  passive tracers common variables 
-   USE trcdta
+   USE trcdta          !
    USE sms_pisces      !  PISCES Source Minus Sink variables
    USE p4zbio          !  Biological model
@@ -24,9 +24,10 @@
    USE p4zsed          !  Sedimentation
    USE p4zint          !  time interpolation
-   USE iom             !  I/O manager
    USE trdmod_oce      !  Ocean trends variables
    USE trdmod_trc      !  TOP trends variables
    USE sedmodel        !  Sediment model
+   !
    USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -34,5 +35,5 @@
 
    PUBLIC   p4z_sms_init    ! called in p4zsms.F90
-   PUBLIC   p4z_sms    ! called in p4zsms.F90
+   PUBLIC   p4z_sms         ! called in p4zsms.F90
 
    REAL(wp) :: alkbudget, no3budget, silbudget, ferbudget
@@ -58,5 +59,4 @@
       !!              - ...
       !!---------------------------------------------------------------------
-      !
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
@@ -73,5 +73,5 @@
             jl = jn + jp_pcs0 - 1
             ztrdpis(:,:,:,jn) = trn(:,:,:,jl)
-         ENDDO
+         END DO
       ENDIF
       !
@@ -91,16 +91,15 @@
          !
          ndayflxtr = nday_year
-
+         !
          IF(lwp) write(numout,*)
          IF(lwp) write(numout,*) ' New chemical constants and various rates for biogeochemistry at new day : ', nday_year
          IF(lwp) write(numout,*) '~~~~~~'
-
+         !
          CALL p4z_che              ! computation of chemical constants
          CALL p4z_int( kt )        ! computation of various rates for biogeochemistry
          !
       ENDIF
-
-      IF( ll_sbc ) CALL p4z_sbc( kt )   ! external sources of nutrients 
-
+      IF( ll_sbc )   CALL p4z_sbc( kt )   ! external sources of nutrients 
+      !
       DO jnt = 1, nrdttrc          ! Potential time splitting if requested
          !
@@ -110,5 +109,5 @@
          DO jn = jp_pcs0, jp_pcs1
             trb(:,:,:,jn) = trn(:,:,:,jn)
-         ENDDO
+         END DO
          !
       END DO
@@ -118,5 +117,5 @@
             jl = jn + jp_pcs0 - 1
             ztrdpis(:,:,:,jn) = ( ztrdpis(:,:,:,jn) - trn(:,:,:,jl) ) * rfact2r
-         ENDDO
+         END DO
       ENDIF
 
@@ -152,10 +151,10 @@
       !
       CALL p4z_chk_mass( kt ) ! Mass conservation checking
-
-      IF ( kt == nittrc000 ) CALL FLUSH    ( numonp )     ! flush output namelist PISCES
-      IF( nn_timing == 1 )  CALL timing_stop('p4z_sms')
-      !
+      !
+      IF( kt == nittrc000 )   CALL FLUSH    ( numonp )     ! flush output namelist PISCES
+      IF( nn_timing == 1  )   CALL timing_stop('p4z_sms')
       !
    END SUBROUTINE p4z_sms
+
 
    SUBROUTINE p4z_sms_init
@@ -260,6 +259,7 @@
          WRITE(numout,*) '    Flag to check mass conservation of NO3/Si/TALK ln_check_mass = ', ln_check_mass
       ENDIF
-
+      !
    END SUBROUTINE p4z_sms_init
+
 
    SUBROUTINE p4z_ph_ini
@@ -291,4 +291,5 @@
    END SUBROUTINE p4z_ph_ini
 
+
    SUBROUTINE p4z_rst( kt, cdrw )
       !!---------------------------------------------------------------------
@@ -341,4 +342,5 @@
    END SUBROUTINE p4z_rst
 
+
    SUBROUTINE p4z_dmp( kt )
       !!----------------------------------------------------------------------
@@ -347,6 +349,5 @@
       !! ** purpose  : Relaxation of some tracers
       !!----------------------------------------------------------------------
-      !
-      INTEGER, INTENT( in )  ::     kt ! time step
+      INTEGER, INTENT(in) ::   kt   ! time step
       !
       REAL(wp) ::  alkmean = 2426.     ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
@@ -357,5 +358,4 @@
       REAL(wp) :: zarea, zalksum, zpo4sum, zno3sum, zsilsum
       !!---------------------------------------------------------------------
-
 
       IF(lwp)  WRITE(numout,*)
@@ -386,5 +386,5 @@
          !
       ENDIF
-
+      !
    END SUBROUTINE p4z_dmp
 
@@ -397,9 +397,7 @@
       !!
       !!---------------------------------------------------------------------
-      !
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
-      !!
-      !!---------------------------------------------------------------------
-
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index      
+      !!---------------------------------------------------------------------
+      !
       IF( kt == nittrc000 ) THEN 
          IF( ln_check_mass .AND. lwp) THEN      !   Open budget file of NO3, ALK, Si, Fer
@@ -434,6 +432,5 @@
             &                    + trn(:,:,:,jpzoo) * ferat3            &
             &                    + trn(:,:,:,jpmes) * ferat3            ) * cvol(:,:,:)  )
-
-         !
+            !
          t_atm_co2_flx  = t_atm_co2_flx / glob_sum( e1e2t(:,:) )
          t_oce_co2_flx  = t_oce_co2_flx         * 12. / 1.e15 * (-1 )
@@ -452,8 +449,8 @@
          !
       ENDIF
-       !
- 9000  FORMAT(i8,f10.5,e18.10,f10.5,f10.5)
- 9500  FORMAT(i8,4e18.10)     
-       !
+      !
+ 9000 FORMAT(i8,f10.5,e18.10,f10.5,f10.5)
+ 9500 FORMAT(i8,4e18.10)     
+      !
    END SUBROUTINE p4z_chk_mass
 
Index: branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 4616)
+++ branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 4617)
@@ -23,6 +23,6 @@
    USE traadv_ubs      ! UBS      scheme           (tra_adv_ubs    routine)
    USE traadv_qck      ! QUICKEST scheme           (tra_adv_qck    routine)
-   USE traadv_eiv      ! eddy induced velocity     (tra_adv_eiv    routine)
-   USE ldftra_oce      ! lateral diffusion coefficient on tracers
+   USE ldftra          ! lateral diffusion: eddy diffusivity & EIV coeff.
+   USE ldfslp          ! Lateral diffusion: slopes of neutral surfaces
    USE prtctl_trc      ! Print control
 
@@ -41,5 +41,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! NEMO/TOP 3.7 , NEMO Consortium (2014)
    !! $Id$ 
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
@@ -51,9 +51,6 @@
       !!                  ***  ROUTINE trc_adv_alloc  ***
       !!----------------------------------------------------------------------
-
       ALLOCATE( r2dt(jpk), STAT=trc_adv_alloc )
-
-      IF( trc_adv_alloc /= 0 ) CALL ctl_warn('trc_adv_alloc : failed to allocate array.')
-
+      IF( trc_adv_alloc /= 0 )   CALL ctl_warn('trc_adv_alloc : failed to allocate array.')
    END FUNCTION trc_adv_alloc
 
@@ -67,10 +64,9 @@
       !! ** Method  : - Update the tracer with the advection term following nadv
       !!----------------------------------------------------------------------
-      !!
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !
       INTEGER ::   jk 
       CHARACTER (len=22) ::   charout
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zun, zvn, zwn  ! effective velocity
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zun, zvn, zwn   ! effective transport
       !!----------------------------------------------------------------------
       !
@@ -79,8 +75,7 @@
       CALL wrk_alloc( jpi, jpj, jpk, zun, zvn, zwn )
       !
-
       IF( kt == nittrc000 )   CALL trc_adv_ctl          ! initialisation & control of options
-
-      IF( ln_top_euler) THEN
+      !
+      IF( ln_top_euler ) THEN
          r2dt(:) =  rdttrc(:)              ! = rdttrc (use Euler time stepping)
       ELSE
@@ -92,18 +87,26 @@
       ENDIF
 
-      !                                                   ! effective transport
+      !                                               !==  effective transport  ==!
       DO jk = 1, jpkm1
-         !                                                ! eulerian transport only
-         zun(:,:,jk) = e2u  (:,:) * fse3u(:,:,jk) * un(:,:,jk)
+         zun(:,:,jk) = e2u  (:,:) * fse3u(:,:,jk) * un(:,:,jk)                   ! eulerian transport
          zvn(:,:,jk) = e1v  (:,:) * fse3v(:,:,jk) * vn(:,:,jk)
          zwn(:,:,jk) = e1e2t(:,:)                 * wn(:,:,jk)
-         !
       END DO
-      zwn(:,:,jpk) = 0.e0                                 ! no transport trough the bottom
-
-      IF( lk_traldf_eiv .AND. .NOT. ln_traldf_grif )   &  ! add the eiv transport (if necessary)
-         &              CALL tra_adv_eiv( kt, nittrc000, zun, zvn, zwn, 'TRC' )
+!!gm      IF( ln_vvl_ztilde .OR. ln_vvl_layer ) THEN        !!gm to be added like on T and S ????
+!!gm         zun(:,:,:) = zun(:,:,:) + un_td(:,:,:)
+!!gm         zvn(:,:,:) = zvn(:,:,:) + vn_td(:,:,:)
+!!gm      ENDIF
+      zun(:,:,jpk) = 0._wp                                                       ! no transport in the bottom
+      zvn(:,:,jpk) = 0._wp                                                       ! no transport in the bottom
+      zwn(:,:,jpk) = 0.e0                                                        ! no transport trough the bottom
+
+      IF( ln_ldfeiv .AND. .NOT. ln_traldf_triad )   &       
+         &              CALL ldf_eiv_trp( kt, nittrc000, zun, zvn, zwn, 'TRC' )  ! add the eiv transport (if necessary)
+      !
+!!gm  to be added like in T and S ?
+!!gm      IF( ln_mle    )   CALL tra_adv_mle( kt, nittrc000, zun, zvn, zwn, 'TRC' )  ! add the mle transport (if necessary)
       !
       SELECT CASE ( nadv )                            !==  compute advection trend and add it to general trend  ==!
+      !
       CASE ( 1 )   ;    CALL tra_adv_cen2  ( kt, nittrc000, 'TRC',       zun, zvn, zwn, trb, trn, tra, jptra )   !  2nd order centered
       CASE ( 2 )   ;    CALL tra_adv_tvd   ( kt, nittrc000, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  TVD 
@@ -132,5 +135,4 @@
          WRITE(charout, FMT="('adv6')")  ; CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
-         !
       END SELECT
 
@@ -157,5 +159,5 @@
       INTEGER ::   ioptio
       !!----------------------------------------------------------------------
-
+      !
       ioptio = 0                      ! Parameter control
       IF( ln_trcadv_cen2   )   ioptio = ioptio + 1
Index: branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 4616)
+++ branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 4617)
@@ -4,27 +4,26 @@
    !! Ocean Passive tracers : lateral diffusive trends
    !!=====================================================================
-   !! History :  9.0  ! 2005-11 (G. Madec)  Original code
-   !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA
+   !! History :  1.0  ! 2005-11  (G. Madec)  Original code
+   !!            3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA
+   !!            3.7  ! 2014-03  (G. Madec)  LDF simplification
    !!----------------------------------------------------------------------
 #if defined key_top
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   trc_ldf     : update the tracer trend with the lateral diffusion
    !!       ldf_ctl : initialization, namelist read, and parameters control
    !!----------------------------------------------------------------------
-   USE oce_trc         ! ocean dynamics and active tracers
-   USE trc             ! ocean passive tracers variables
-   USE trcnam_trp      ! passive tracers transport namelist variables
-   USE ldftra_oce      ! lateral diffusion coefficient on tracers
-   USE ldfslp          ! ???
-   USE traldf_bilapg   ! lateral mixing            (tra_ldf_bilapg routine)
-   USE traldf_bilap    ! lateral mixing            (tra_ldf_bilap routine)
-   USE traldf_iso      ! lateral mixing            (tra_ldf_iso routine)
-   USE traldf_iso_grif ! lateral mixing          (tra_ldf_iso_grif routine)
-   USE traldf_lap      ! lateral mixing            (tra_ldf_lap routine)
+   USE trc              ! ocean passive tracers variables
+   USE oce_trc          ! ocean dynamics and active tracers
+   USE trcnam_trp       ! passive tracers transport namelist variables
+   USE ldftra           ! lateral diffusion: eddy diffusivity & EIV coeff.
+   USE ldfslp           ! lateral diffusion: iso-neutral slope 
+   USE traldf_lap       ! lateral diffusion: iso-level lap/blp (tra_ldf_lap/_blp  routine)
+   USE traldf_iso       ! lateral diffusion (Madec operator)   (tra_ldf_iso       routine)
+   USE traldf_iso_triad ! lateral diffusion (triad operator)   (tra_ldf_iso_triad routine)
    USE trdmod_oce
    USE trdtra
+   !
    USE prtctl_trc      ! Print control
 
@@ -40,9 +39,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! NEMO/TOP 3.7 , NEMO Consortium (2014)
    !! $Id$
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -63,5 +61,8 @@
       IF( nn_timing == 1 )   CALL timing_start('trc_ldf')
       !
+      
+!!gm  this call should be put in trcini !
       IF( kt == nittrc000 )   CALL ldf_ctl          ! initialisation & control of options
+!!gm end
 
       rldf = rldf_rat
@@ -73,31 +74,28 @@
 
       SELECT CASE ( nldf )                       ! compute lateral mixing trend and add it to the general trend
-      CASE ( 0 )   ;   CALL tra_ldf_lap   ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra            )  ! iso-level laplacian
-      CASE ( 1 )                                                                                            ! rotated laplacian
-                       IF( ln_traldf_grif ) THEN
-                          CALL tra_ldf_iso_grif( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra, rn_ahtb_0 )
-                       ELSE
-                          CALL tra_ldf_iso     ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra, rn_ahtb_0 )
-                       ENDIF
-      CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra            )  ! iso-level bilaplacian
-      CASE ( 3 )   ;   CALL tra_ldf_bilapg( kt, nittrc000, 'TRC',             trb, tra, jptra            )  ! s-coord. horizontal bilaplacian
+      CASE ( 0 )   ;   CALL tra_ldf_lap     ( kt, nittrc000, 'TRC', gtru, gtrv, ahtu, ahtv, trb     , tra, jpts, 1)  ! iso-level laplacian
+      CASE ( 1 )                                                                                      ! rotated laplacian
+         IF( ln_traldf_triad ) THEN                                                          
+                       CALL tra_ldf_iso_triad( kt, nittrc000,'TRC', gtru, gtrv, ahtu, ahtv, trb, trb, tra, jpts, 1 )    ! triad operator
+         ELSE                                                                                
+                       CALL tra_ldf_iso      ( kt, nittrc000,'TRC', gtru, gtrv, ahtu, ahtv, trb, trb, tra, jpts, 1 )    ! Madec operator
+         ENDIF
+      CASE ( 2 )   ;   CALL tra_ldf_blp      ( kt, nittrc000,'TRC', gtru, gtrv, ahtu, ahtv, trb     , tra, jpts )    ! iso-level bilaplacian
+      CASE ( 3 )   ;   CALL tra_ldf_iso_blp  ( kt, nittrc000,'TRC', gtru, gtrv, ahtu, ahtv, trb     , tra, jpts )    ! rotated   bilaplacian
          !
-      CASE ( -1 )                                     ! esopa: test all possibility with control print
-         CALL tra_ldf_lap   ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra            )
-         WRITE(charout, FMT="('ldf0 ')") ;  CALL prt_ctl_trc_info(charout)
-                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
-         IF( ln_traldf_grif ) THEN
-            CALL tra_ldf_iso_grif( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra, rn_ahtb_0 )
-         ELSE
-            CALL tra_ldf_iso     ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra, rn_ahtb_0 )
-         ENDIF
-         WRITE(charout, FMT="('ldf1 ')") ;  CALL prt_ctl_trc_info(charout)
-                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
-         CALL tra_ldf_bilap ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra            )
-         WRITE(charout, FMT="('ldf2 ')") ;  CALL prt_ctl_trc_info(charout)
-                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
-         CALL tra_ldf_bilapg( kt, nittrc000, 'TRC',             trb, tra, jptra            )
-         WRITE(charout, FMT="('ldf3 ')") ;  CALL prt_ctl_trc_info(charout)
-                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+      CASE ( -1 )                                ! esopa: test all possibility with control print
+         CALL tra_ldf_lap   ( kt, nittrc000, 'TRC', gtru, gtrv, ahtu, ahtv, trb, tra, jpts, 1 ) 
+         WRITE(charout, FMT="('ldf0')")   ;   CALL prt_ctl_trc_info(charout)
+                                              CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+         IF( ln_traldf_triad ) THEN
+            CALL tra_ldf_iso_triad( kt, nittrc000, 'TRC', gtru, gtrv, ahtu, ahtv, trb, trb, tra, jpts, 1 )
+         ELSE
+            CALL tra_ldf_iso      ( kt, nittrc000, 'TRC', gtru, gtrv, ahtu, ahtv, trb, trb, tra, jpts, 1 )  
+         ENDIF
+         WRITE(charout, FMT="('ldf1')")   ;   CALL prt_ctl_trc_info(charout)
+                                              CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+         CALL tra_ldf_blp   ( kt, nittrc000, 'TRC', gtru, gtrv, ahtu, ahtv, trb, tra, jpts        ) 
+         WRITE(charout, FMT="('ldf2')")   ;   CALL prt_ctl_trc_info(charout)
+                                              CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       END SELECT
       !
@@ -111,6 +109,6 @@
       !                                          ! print mean trends (used for debugging)
       IF( ln_ctl )   THEN
-         WRITE(charout, FMT="('ldf ')") ;  CALL prt_ctl_trc_info(charout)
-                                           CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+         WRITE(charout, FMT="('ldf ')")   ;   CALL prt_ctl_trc_info(charout)
+                                              CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
       !
@@ -119,4 +117,5 @@
    END SUBROUTINE trc_ldf
 
+!!gm ldf_ctl should be called in trcini  so that l_ldfslp=T  cause the slope init and calculation
 
    SUBROUTINE ldf_ctl
@@ -155,4 +154,8 @@
       IF( ioptio >  1 )   CALL ctl_stop( '          use ONE or NONE of the 2 lap/bilap operator type on tracer' )
       IF( ioptio == 0 )   nldf = -2   ! No lateral diffusion
+      
+      IF( ln_traldf_lap .AND. ln_trcldf_bilap )   CALL ctl_stop( ' bilaplacian should be used on both TRC and TRA' )
+      IF( ln_traldf_blp .AND. ln_trcldf_lap   )   CALL ctl_stop( '   laplacian should be used on both TRC and TRA' )
+      
       ioptio = 0
       IF( ln_trcldf_level )   ioptio = ioptio + 1
@@ -202,12 +205,9 @@
       IF( ierr == 1 )   CALL ctl_stop( ' iso-level in z-coordinate - partial step, not allowed' )
       IF( ierr == 2 )   CALL ctl_stop( ' isoneutral bilaplacian operator does not exist' )
-      IF( lk_traldf_eiv .AND. .NOT.ln_trcldf_iso )   &
+      IF( ln_ldfeiv .AND. .NOT.ln_trcldf_iso )   &
            CALL ctl_stop( '          eddy induced velocity on tracers',   &
            &              ' the eddy induced velocity on tracers requires isopycnal laplacian diffusion' )
       IF( nldf == 1 .OR. nldf == 3 ) THEN      ! rotation
-         IF( .NOT.lk_ldfslp )   CALL ctl_stop( '          the rotation of the diffusive tensor require key_ldfslp' )
-#if defined key_offline
-         l_traldf_rot = .TRUE.                 ! needed for trazdf_imp
-#endif
+         IF( .NOT.l_ldfslp )   CALL ctl_stop( '          the rotation of the diffusive tensor require l_ldfslp' )
       ENDIF
 
Index: branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 4616)
+++ branches/2014/dev_CNRS0_NOC1_LDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 4617)
@@ -107,8 +107,4 @@
       END DO
 
-
-#if defined key_obc
-!!      CALL obc_trc( kt )               ! OBC open boundaries
-#endif
 #if defined key_bdy
 !!      CALL bdy_trc( kt )               ! BDY open boundaries
